<script lang="ts">
  import type { Player } from "../server";

  export let players: Player[];

  $: sortedPlayers = players;
  $: {
    let temp = [...players];
    temp.sort((a, b) => {
      if (a.score > b.score) {
        return -1;
      } else if (a.score < b.score) {
        return 1;
      } else {
        return 0;
      }
    });
    sortedPlayers = temp;
  }

  function getRank(player: Player, allPlayers: Player[]) {
    let rank = allPlayers.filter((p) => p.score > player.score).length + 1;
    if (rank === 1) {
      return "🥇";
    } else if (rank === 2) {
      return "🥈";
    } else if (rank === 3) {
      return "🥉";
    } else {
      return rank;
    }
  }
</script>

<h2>Game complete!</h2>
<table>
  <thead>
    <tr>
      <th class="rank">#</th>
      <th class="player">Player</th>
      <th class="score">Score</th>
    </tr>
  </thead>
  <tbody>
    {#each sortedPlayers as player}
      <tr>
        <td>{getRank(player, players)}</td>
        <td class="player">
          <gs6-user playerid={player.id} />
        </td>
        <td class="score">{player.score}</td>
      </tr>
    {/each}
  </tbody>
</table>

<style>
  .player {
    text-align: left;
    min-width: 10em;
  }
  .score {
    text-align: right;
  }
</style>
